#ifndef TYPE_H
#define TYPE_H

typedef struct {
	Xv_opaque frame;
	Xv_opaque panel;
	Xv_opaque new;
	Xv_opaque open;
	Xv_opaque filemenu;
	Xv_opaque entrymenu;
	Xv_opaque entry;
	Xv_opaque searchmenu;
	Xv_opaque search;
	Xv_opaque dialmenu;
	Xv_opaque dial;
	Xv_opaque classlist;
	Xv_opaque entrylist;
} parent_objects;

typedef struct {
	Xv_opaque frame;
	Xv_opaque panel;
	Xv_opaque name;
	Xv_opaque class;
	Xv_opaque phone;
	Xv_opaque fax;
	Xv_opaque area;
	Xv_opaque address;
	Xv_opaque email;
	Xv_opaque notes[4];
} info_objects;

typedef struct {
	Xv_opaque frame;
	Xv_opaque panel;
	Xv_opaque firstname;
	Xv_opaque lastname;
	Xv_opaque class;
	Xv_opaque classchoice;
	Xv_opaque areachoice;
	Xv_opaque countrycode;
	Xv_opaque areacode;
	Xv_opaque phone;
	Xv_opaque fax;
	Xv_opaque address;
	Xv_opaque city;
	Xv_opaque state;
	Xv_opaque zip;
	Xv_opaque country;
	Xv_opaque email;
	Xv_opaque notes[4];
	Xv_opaque apply;
	Xv_opaque addmore;
} entry_objects;

typedef struct {
	Xv_opaque frame;
	Xv_opaque panel;
	Xv_opaque checkbox;
	Xv_opaque firstname;
	Xv_opaque lastname;
	Xv_opaque search;
	Xv_opaque entrylist;
} name_search_objects;

typedef struct {
	Xv_opaque frame;
	Xv_opaque panel;
	Xv_opaque checkbox;
	Xv_opaque countrycode;
	Xv_opaque areacode;
	Xv_opaque phone;
	Xv_opaque search;
	Xv_opaque entrylist;
} phone_search_objects;

typedef struct {
	Xv_opaque frame;
	Xv_opaque panel;
	Xv_opaque checkbox;
	Xv_opaque address;
	Xv_opaque city;
	Xv_opaque state;
	Xv_opaque zip;
	Xv_opaque country;
	Xv_opaque search;
	Xv_opaque entrylist;
} address_search_objects;

typedef struct {
	Xv_opaque frame;
	Xv_opaque panel;
	Xv_opaque prefix;
	Xv_opaque devfile;
	Xv_opaque torp; /* Tone or Pulse */
	Xv_opaque apply;
} dial_objects;

typedef enum {
	NOTICE_TYPE_OK,
	NOTICE_TYPE_YES_NO
} Notice_type;

typedef struct {
	int  number; /* 9 bytes */
	char first[22];
	char last[22];
	char class[22];
	char countrycode[12];
	char areacode[12];
	char phone[17];
	char fax[17];
	int  area; /* 1 bytes */
	char address[42];
	char city[42];
	char state[22];
	char zip[22];
	char country[22];
	char email[52];
	char notes[4][52];
} Person_information;	/* Total 510 (+ 14) bytes */

typedef enum {
	FILE_OPEN_EXISTING,
	FILE_OPEN_NEW
} File_open_type;

typedef enum {
	UPDATE_NEW,
	UPDATE_EDIT,
	UPDATE_NEW_MORE
} Update_type;

typedef enum {
	SEARCH_NAME,
	SEARCH_PHONE,
	SEARCH_ADDRESS
} Search_type;

struct __number_field {
	char first[22];
	char last[22];
	int  number;
	struct __number_field *forward;
	struct __number_field *backward;
};

struct __class_field {
	char class[22];
	struct __number_field *num_p;
	struct __class_field *forward;
	struct __class_field *backward;
};

typedef struct __number_field Number_field;
typedef struct __class_field  Class_field;


#endif
